/*
 * Copyright (c) 2006-2007 CACE Technologies, Davis (California)
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1. Redistributions of source code must retain the above copyright
 * notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 * notice, this list of conditions and the following disclaimer in the
 * documentation and/or other materials provided with the distribution.
 * 3. Neither the name of CACE Technologies nor the names of its 
 * contributors may be used to endorse or promote products derived 
 * from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */

#if !defined(AFX_KISMETCONFDLG_H__A5F43345_F6FB_4E2F_AF26_EBDEC423A593__INCLUDED_)
#define AFX_KISMETCONFDLG_H__A5F43345_F6FB_4E2F_AF26_EBDEC423A593__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

typedef struct _AdapterIdentifier
{
	CString Name;
	CString Description;
}AdapterIdentifier, *pAdapterIdentifier;

/////////////////////////////////////////////////////////////////////////////
// CKismetConfDlg dialog

class CKismetConfDlg : public CDialog
{
// Construction
public:
	CKismetConfDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CKismetConfDlg)
	enum { IDD = IDD_KISMETCONF_DIALOG };
	CListCtrl	m_ListDrones;
	CEdit	m_EditDrones;
	CComboBox	m_ComboSources;
	CButton	m_CheckEnableLogging;
	CButton	m_ButtonEditUiConf;
	CButton	m_ButtonEditDroneConf;
	CButton	m_ButtonEditKismetConf;
	CButton	m_ButtonDronesRemove;
	CButton	m_ButtonDronesClear;
	CButton	m_ButtonDronesAdd;
	CButton	m_ButtonRunKismet;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CKismetConfDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CKismetConfDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnRadioSpecifyAdapter();
	afx_msg void OnRadioNoLocalSources();
	afx_msg void OnRadioAllLocalSources();
	afx_msg void OnButtonEditConf();
	afx_msg void OnButtonEditUi();
	afx_msg void OnButtonEditDrone();
	afx_msg void OnButtonDronesAdd();
	virtual void OnOK();
	afx_msg void OnButtonDronesClear();
	afx_msg void OnButtonDronesRemove();
	afx_msg void OnButtonRunkismet();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	static HANDLE CmdExec(char * Cmd, char* args, BOOL Wait);
	UINT FillAdapterList();
	UINT SaveConfig();
	UINT LoadConfig();

	CArray<AdapterIdentifier, AdapterIdentifier&> m_AdaptersList;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_KISMETCONFDLG_H__A5F43345_F6FB_4E2F_AF26_EBDEC423A593__INCLUDED_)
